# AWS Services Supported

The alpha SDK for Rust currently supports the checked services below. If you want to see a particular service added, please add your "+1" to the GitHub issue corresponding to the service. If the Issue doesn't exist yet, feel free to create one! This will help us prioritize adding new services to the SDK. 

- [x] Amazon API Gateway
- [x] Amazon Dynamodb
- [x] Amazon Kinesis
- [x] Amazon KMS
- [x] Amazon Polly
- [x] Amazon Secrets Manager
- [X] Amazon Qldb
- [X] Amazon Qldb-Session
- [X] Amazon Lambda
- [x] [Amazon S3](https://github.com/awslabs/aws-sdk-rust/issues/16)
- [x] [Amazon SSM](https://github.com/awslabs/aws-sdk-rust/issues/22)
- [x] [Amazon SQS](https://github.com/awslabs/aws-sdk-rust/issues/19)
- [x] [Amazon ECS](https://github.com/awslabs/aws-sdk-rust/issues/28)
- [x] Amazon Batch
- [x] [Amazon Route 53](https://github.com/awslabs/aws-sdk-rust/issues/35)
- [x] [Amazon RDS](https://github.com/awslabs/aws-sdk-rust/issues/36)
- [x] Amazon Rds-Data
- [x] [Amazon IAM](https://github.com/awslabs/aws-sdk-rust/issues/21)
- [x] [Amazon SNS](https://github.com/awslabs/aws-sdk-rust/issues/26)
- [x] [Amazon Sts](https://github.com/awslabs/aws-sdk-rust/issues/17)
- [x] Amazon Medialive
- [x] Amazon Mediapackage
- [x] [Amazon Cloud Formation](https://github.com/awslabs/aws-sdk-rust/issues/25)
- [x] Amazon Sagemaker
- [x] Amazon Sagemaker-A2I-Runtime
- [x] Amazon Runtime.Sagemaker
- [x] [Amazon Ec2](https://github.com/awslabs/aws-sdk-rust/issues/18)
- [x] [Amazon SES v2](https://github.com/awslabs/aws-sdk-rust/issues/27)
- [x] [Amazon Cloudwatch Logs](https://github.com/awslabs/aws-sdk-rust/issues/30)
- [x] [Amazon ECR](https://github.com/awslabs/aws-sdk-rust/issues/34)
- [x] [Amazon EKS](https://github.com/awslabs/aws-sdk-rust/issues/67)
- [x] [Amazon Cloudwatch Metrics](https://github.com/awslabs/aws-sdk-rust/issues/20)
- [x] [Amazon EBS](https://github.com/awslabs/aws-sdk-rust/issues/66)
- [x] [Amazon Config](https://github.com/awslabs/aws-sdk-rust/issues/31)
- [x] [Amazon Cognito Identity](https://github.com/awslabs/aws-sdk-rust/issues/124)
- [x] [Amazon Cognito Identity Provider](https://github.com/awslabs/aws-sdk-rust/issues/124)
- [x] [Amazon Cognito Sync](https://github.com/awslabs/aws-sdk-rust/issues/124)
- [x] Amazon Snowball
- [x] [Amazon Auto Scaling](https://github.com/awslabs/aws-sdk-rust/issues/33)
- [x] Amazon Autoscaling
- [x] Amazon Autoscaling-Plans

------
- [ ] Amazon Access Analyzer
- [ ] Amazon ACM
- [ ] Amazon Acm-Pca
- [ ] Amazon Alexa For Business
- [ ] Amazon Amplify
- [ ] Amazon API Gateway Management API
- [ ] Amazon API Gateway v2
- [ ] Amazon App Config
- [ ] Amazon App Flow
- [ ] Amazon Application-Insights
- [ ] Amazon Appmesh
- [ ] Amazon Appstream
- [ ] Amazon App Sync
- [ ] Amazon Athena
- [ ] Amazon Awsmigrationhub
- [ ] Amazon Backup
- [ ] Amazon Braket
- [ ] Amazon Budgets
- [ ] Amazon Ce
- [ ] Amazon Chime
- [ ] Amazon Cloud9
- [ ] Amazon Cloud Directory
- [ ] Amazon Cloud Front
- [ ] Amazon Cloudhsm
- [ ] Amazon Cloudhsmv2
- [ ] Amazon Cloudsearch
- [ ] Amazon Cloudsearchdomain
- [ ] Amazon Cloud Trail
- [ ] Amazon Code Artifact
- [ ] Amazon Code Build
- [ ] Amazon Code Commit
- [ ] Amazon Code Deploy
- [ ] Amazon Code Guru Profiler
- [ ] Amazon Code Guru Reviewer
- [ ] Amazon Code Pipeline
- [ ] Amazon Codestar
- [ ] Amazon Codestar-Connections
- [ ] Amazon Codestar-Notifications
- [ ] Amazon Comprehend
- [ ] Amazon Comprehendmedical
- [ ] Amazon Compute-Optimizer
- [ ] Amazon Connect
- [ ] Amazon Connectparticipant
- [ ] Amazon Cur
- [ ] Amazon Databrew
- [ ] Amazon Dataexchange
- [ ] Amazon Datapipeline
- [ ] Amazon Datasync
- [ ] Amazon Dax
- [ ] Amazon Detective
- [ ] Amazon Device Farm
- [ ] Amazon Direct Connect
- [ ] Amazon Discovery
- [ ] Amazon Dlm
- [ ] Amazon DMS
- [ ] Amazon Docdb
- [ ] Amazon DS
- [ ] Amazon Ec2-Instance-Connect
- [ ] Amazon Elasticache
- [ ] Amazon Elastic Beanstalk
- [ ] Amazon Elastic Filesystem
- [ ] Amazon Elastic Inference
- [ ] Amazon Elastic Load Balancing
- [ ] Amazon Elastic Load Balancing v2
- [ ] Amazon Elastic Map Reduce
- [ ] Amazon Elastic Transcoder
- [ ] Amazon Email
- [ ] Amazon Entitlement.Marketplace
- [ ] Amazon ES
- [ ] Amazon Eventbridge
- [ ] Amazon Events
- [ ] Amazon Firehose
- [ ] Amazon FMS
- [ ] Amazon Forecast
- [ ] Amazon Forecast Query
- [ ] Amazon Fraud Detector
- [ ] Amazon FSX
- [ ] Amazon Gamelift
- [ ] Amazon Glacier
- [ ] Amazon Global Accelerator
- [ ] Amazon Glue
- [ ] Amazon Greengrass
- [ ] Amazon Groundstation
- [ ] Amazon Guardduty
- [ ] Amazon Health
- [ ] Amazon Honeycode
- [ ] Amazon Identitystore
- [ ] Amazon Imagebuilder
- [ ] Amazon Inspector
- [ ] Amazon IOT
- [ ] Amazon Iot1Click-Devices
- [ ] Amazon Iot1Click-Projects
- [ ] Amazon IoT Analytics
- [ ] Amazon IoT Data
- [ ] Amazon IoT Events
- [ ] Amazon Iotevents-Data
- [ ] Amazon Iot-Jobs-Data
- [ ] Amazon Iotsecuretunneling
- [ ] Amazon Iotsitewise
- [ ] Amazon Iotthingsgraph
- [ ] Amazon Ivs
- [ ] Amazon Kafka
- [ ] Amazon Kendra
- [ ] Amazon Kinesis Analytics
- [ ] Amazon Kinesis Analytics v2
- [ ] Amazon Kinesis Video
- [ ] Amazon Kinesis-Video-Archived-Media
- [ ] Amazon Kinesis-Video-Media
- [ ] Amazon Kinesis-Video-Signaling
- [ ] Amazon Lake Formation
- [ ] Amazon Lambda
- [ ] Amazon Lex-Models
- [ ] Amazon License-Manager
- [ ] Amazon Lightsail
- [ ] Amazon Logs
- [ ] Amazon Machine Learning
- [ ] Amazon Macie
- [ ] Amazon Macie2
- [ ] Amazon Managedblockchain
- [ ] Amazon Marketplace-Catalog
- [ ] Amazon Marketplacecommerceanalytics
- [ ] Amazon Mediaconnect
- [ ] Amazon Mediaconvert
- [ ] Amazon Mediapackage-Vod
- [ ] Amazon Mediastore
- [ ] Amazon Mediastore-Data
- [ ] Amazon Mediatailor
- [ ] Amazon Meteringmarketplace
- [ ] Amazon Migrationhub-Config
- [ ] Amazon Mobile
- [ ] Amazon Monitoring
- [ ] Amazon Mq
- [ ] Amazon Mturk-Requester
- [ ] Amazon Neptune
- [ ] Amazon Network-Firewall
- [ ] Amazon Networkmanager
- [ ] Amazon Ops Works
- [ ] Amazon Opsworkscm
- [ ] Amazon Organizations
- [ ] Amazon Outposts
- [ ] Amazon Personalize
- [ ] Amazon Personalize-Events
- [ ] Amazon Personalize-Runtime
- [ ] Amazon Pi
- [ ] Amazon Pinpoint
- [ ] Amazon Pinpoint-Email
- [ ] Amazon Pricing
- [ ] Amazon Quicksight
- [ ] Amazon RAM
- [ ] Amazon Redshift
- [ ] Amazon Redshift-Data
- [ ] Amazon Rekognition
- [ ] Amazon Resource-Groups
- [ ] Amazon Resourcegroupstaggingapi
- [ ] Amazon Robomaker
- [ ] Amazon Route53Domains
- [ ] Amazon Route53Resolver
- [ ] Amazon Runtime.Lex
- [ ] Amazon S3Control
- [ ] Amazon S3Outposts
- [ ] Amazon Savingsplans
- [ ] Amazon Schemas
- [ ] Amazon Securityhub
- [ ] Amazon Serverlessrepo
- [ ] Amazon Servicecatalog
- [ ] Amazon Servicecatalog-Appregistry
- [ ] Amazon Service Discovery
- [ ] Amazon Service-Quotas
- [ ] Amazon Shield
- [ ] Amazon Signer
- [ ] Amazon SMS
- [ ] Amazon Sms-Voice
- [ ] Amazon SSO
- [ ] Amazon Sso-Admin
- [ ] Amazon Sso-Oidc
- [ ] Amazon States
- [ ] Amazon Storagegateway
- [ ] Amazon Streams.Dynamodb
- [ ] Amazon Support
- [ ] Amazon Swf
- [ ] Amazon Synthetics
- [ ] Amazon Textract
- [ ] Amazon Timestream-Query
- [ ] Amazon Timestream-Write
- [ ] Amazon Transcribe
- [ ] Amazon Transcribe-Streaming
- [ ] Amazon Transfer
- [ ] Amazon Translate
- [ ] Amazon Waf
- [ ] Amazon Waf-Regional
- [ ] [Amazon Wafv2](https://github.com/awslabs/aws-sdk-rust/issues/118)
- [ ] Amazon Workdocs
- [ ] Amazon Worklink
- [ ] Amazon Workmail
- [ ] Amazon Workmailmessageflow
- [ ] Amazon Workspaces
- [ ] Amazon Xray
